CREATE OR REPLACE procedure landscape is
    /* 2. Example:  landscape page  */

  l_blob blob;
 begin
   
    /* Initializes generator program variables: 
      - unit (default): mm 
      - page format (default): A4 */
    plpdf.init(
     p_orientation => 'L' -- Page orientation: Landscape
     ); 
   
    /* Begin a new page.
       If no orientation is given then the orientation 
       specified in Init will be used. */
    plpdf.NewPage;
   
    /* Sets the font and its properties */
    plpdf.SetPrintFont(
     p_family => 'Arial', -- Font family: Arial
     p_style => null,     -- Font style: regular (default)
     p_size => 12         -- Font size: 12 pt
     );
     
    /* Draws a rectangle cell with text inside. 
       The rectangle may have a border and fill color specified. */
    plpdf.PrintCell(
     p_w => 50,                   -- Rectangle width
     p_h => 10,                   -- Rectangle heigth
     p_txt => 'Landscape Example' -- Text in rectangle 
     ); 
     
     /* Returns the generated PDF document. 
        The document is closed and then returned in the OUT parameter. */
    plpdf.SendDoc(
     p_blob => l_blob  -- The generated document
     );
    
    
    /* Print it:
    
	owa_util.mime_header('application/pdf',false);
        htp.p('Content-Length: ' || dbms_lob.getlength(l_blob)); 
        owa_util.http_header_close; 	
        wpg_docload.download_file(l_blob);   */
    
    /* Store */
    insert into STORE_BLOB (blob_file, created_date) values (l_blob, sysdate);
    
    commit;
 end;
/

